# Balogh Szabolcs, NIO402
# 2014 jnius

# Adatok:
param k; # zemek szma
param n; # fogyasztk szma

param s{1..k}; # zem termelse
param d{1..n}; # fogyaszt ignyei
param c{1..k, 1..n}; # tvonal kapacits
param f{1..k, 1..n}; # szlltsi kltsg egy adott tvonalon

# Vltozk: k*n db vltoz bevezetse:
# Jelentse: Mennyit szlltunk i s j pont kztt?
var x{1..k, 1..n} >= 0;


# Felttelek

# k db felttel bevezetse a fogyasztsra
# Egyik zem sem termelhet tbbet a kapacitsnl
subject to sup{i in 1..k}: sum{j in 1..n} x[i,j] <= s[i];

# n db felttel bevezetse a kiszolglshoz
# Minden fogyaszthoz rkezzen meg a szksges mennyisg
# Megj: Lehetne >= is, de a megoldson nem vltoztatna!
s.t. dem{j in 1..n}: sum{i in 1..k} x[i,j] = d[j];

# k*n db felttel bevezetse a szlltshoz
# Minden tvonalon max annyit szllthatunk, amennyi annak a kapacitsa!
cap{i in 1..k, j in 1..n}: x[i,j] <= c[i,j];

# Clfggvny
# A fenti felttelek fggvnyben hogyan lehetne a legolcsbban kiszolglni a fogyasztkat?
minimize cost: sum{i in 1..k, j in 1..n} f[i,j] * x[i,j];

# Ellenrzs: A teljes fogyaszts ne legyen nagyobb, mint a gyrtsi kpessg
# Ha ez elbukik, rgtn dobjon hibt!
check sum{j in 1..n} d[j] < sum{i in 1..k} s[i];

# Megolds keresse
solve;


printf "\n\n\n";

# Eredmny kirsa
# Ez valjban egy dupla for-ciklus!
for {i in 1..k, j in 1..n} {
	# printf "minta", vltozk[]
	# A minta egy if then else szerkezet
	printf (if (x[i,j] > 0) then "Uzem: %2d, Fogy: %2d, Menny: %4d \n" else ""), i, j, x[i,j];
}

# Clfggvny eredmnye
printf "Osszkoltseg: %d\n", cost;

printf "\n\n\n";


# Adat rsz
data;

# k, n, s, d
param k := 2;
param n := 4;
param s :=
	1 200
	2 1400;

param d :=
	1 40
	2 500
	3 300
	4 250;

# kapacits listsan megadsa
param c :=
		1	1	0
		1	2	200
		1	3	200
		1	4	100
		2	1	100
		2	2	450
		2	3	1000
		2	4	200;

# kltsg mtrixosan megadva
param f default 100 (tr)
	 :		1		2 :=
	 1		.		160
	 2		.		180
	 3		60		90
	 4		160		190	;

end;
